/*!
 * Chiffon v2.3.0 - A small ECMAScript parser, tokenizer and minifier written in JavaScript.
 * Copyright (c) 2015 polygon planet <polygon.planet.aqua@gmail.com>
 * @license MIT
 */
!function(a,b,c){"undefined"!=typeof exports?"undefined"!=typeof module&&module.exports?module.exports=c():exports[a]=c():"function"==typeof define&&define.amd?define(c):b[a]=c()}("Chiffon",this,function(){"use strict";function a(a){return new RegExp("(?:(/[*][\\s\\S]*?[*]/)|(//[^"+D+"]*|<!--[^"+D+"]*)|(?:^|("+E+"))(?:"+F+"|)(-->[^"+D+"]*)|("+(a===u?F:J)+")"+G+'|("(?:\\\\\\r\\n|\\\\[\\s\\S]|[^"'+D+"\\\\])*\"|'(?:\\\\\\r\\n|\\\\[\\s\\S]|[^'"+D+"\\\\])*')|("+(a===x?F:I)+")"+G+"|(0(?:[xX][0-9a-fA-F]+|[oO][0-7]+|[bB][01]+)|(?:\\d+(?:[.]\\d*)?|[.]\\d+)(?:[eE][+-]?\\d+)?|[1-9]\\d*|0[0-7]+)|("+H+")"+(a===s?"":"|("+F+")")+"|("+E+")|("+(a===u?"[\\s\\S]":K)+"))","g")}function b(a){return 65535>=a?q(a):(a-=65536,q((a>>10)+55296,a%1024+56320))}function c(a){return 10===a||13===a||8232===a||8233===a}function d(a){return!U.test(a)}function e(a){return!V.test(a)}function f(a){return o.call(arguments,1).forEach(function(b){for(var c=Object.keys(b),d=0,e=c.length;e>d;d++){var f=c[d];a[f]=b[f]}}),a}function g(a){this.options=f({},a||{}),this.line=1,this.index=0,this.prevLineIndex=0}function h(a){this.options=f({},a||{})}function i(a){this.options=f({},a||{},ea)}function j(){}function k(a){this.options=f({},a||{})}var l={},m=Array.prototype,n=(Object.prototype,m.push),o=m.slice,p=m.splice,q=String.fromCharCode,r="Comment",s="WhiteSpace",t="LineTerminator",u="Template",v="String",w="Punctuator",x="RegularExpression",y="Numeric",z="Identifier",A="Null",B="Boolean",C="Keyword",D="\\r\\n\\u2028\\u2029",E="(?:\\r\\n|["+D+"])",F="(?:(?!["+D+"])\\s)+",G="(?=\\s*(?:(?!\\s*[/\\\\<>*%`^\"'\\w$-])[^/\\\\<>*%`^'\"({[\\w$-]|[!=]==?|[|][|]|&&|/[*/]|[,.;:!?)}\\]"+D+"]|$))",H="(?:>>>=?|[.]{3}|<<=|===|!==|>>=|[+][+](?=[+])|--(?=-)|[=!<>*%+/&|^-]=|&&|[|][|]|[+][+]|--|<<|>>|=>|[-+*/%<>=&|^~!?:;,.()[\\]{}])",I="(?:/(?![*/])(?:\\\\[\\s\\S]|\\[(?:\\\\[\\s\\S]|[^\\]"+D+"\\\\])*\\]|[^/"+D+"\\\\])+/(?:[gimuy]+\\b|))",J="`(?:\\\\[\\s\\S]|[$][{](?:\\\\[\\s\\S]|[^{}\\\\]|[{](?:[^{}]*(?:[{][^{}]*[}])?)*[}])*[}]|[^`\\\\])*`",K="(?:\\\\u(?:[0-9a-fA-F]{4}|[{][0-9a-fA-F]+[}])|[^\\s\\\\+/%*=&|^~<>!?:;,.()[\\]{}'\"`@#-])+",L="typeof|in|void|case|instanceof|yield|throw|delete|else|return|do",M="if|while|for|with",N=new RegExp("^(?:"+M+"|"+L+"|var|function|this|new|break|catch|finally|try|default|continue|switch|const|export|import|class|extends|debugger|super|let|static|enum|await|implements|package|protected|interface|private|public)$"),O=new RegExp(E),P=new RegExp("^"+K+"$"),Q=new RegExp("^"+K),R=new RegExp(K+"$"),S=/^[+-]/,T=/[+-]$/,U=/[^{}()[\]<>=!+*%\/&|^~?:;,.-]/,V=/[^0-9]/,W=new RegExp("^"+F),X=new RegExp("(?:(?:^(?:"+L+")$)|(?:(?![.\\]])"+H+"$))"),Y=new RegExp("^(?:"+M+")$"),Z=a(s),$=a(u),_=a(x),aa=a();D=E=F=G=H=I=J=K=L=M=null,g.prototype={parseMatches:function(a,b){for(var c,d,e,f,g,h,i,j,k,l,m,n=0;n<a.length;n++)if(d=a[n],e=d.length,0!==e){if(h=this.line,i=this.index-this.prevLineIndex,m=null,l=this.getTokenType(d),this.options.loc&&(l===v||l===r&&"*"===d.charAt(1)?(g=d.split(O),g.length>1&&(this.line+=g.length-1,this.prevLineIndex=this.index+e-g.pop().length)):l===t&&(this.line++,this.prevLineIndex=this.index+e)),l===x){if(this.fixRegExpTokens(a,n,b,d)){n--;continue}f=d.lastIndexOf("/"),m={pattern:d.substr(1,f-1),flags:d.substring(f+1)}}else if(l===u){this.parseTemplate(d,b,i);continue}this.index+=e,l&&(this.options.parse&&l===t?k=!0:l===r&&!this.options.comment||l===s&&!this.options.whiteSpace||l===t&&!this.options.lineTerminator||(c={type:l,value:d},k&&(c.hasLineTerminator=!0),k=!1,m&&(c.regex=m),this.options.range&&(c.range=[this.index-e,this.index]),this.options.loc&&(j=this.index-this.prevLineIndex,this.addLoc(c,h,i,this.line,j)),b[b.length]=c))}},getTokenType:function(a){var b,f=a.length,g=a.charAt(0);switch(g){case'"':case"'":return v;case"/":return 1===f?w:(g=a.charAt(1),"/"===g||"*"===g?r:2===f&&"="===g?w:x);case".":return 1===f?w:(g=a.charAt(1),"."===g?w:y);case"<":return f>1&&"!"===a.charAt(1)?r:w;case"-":return 3>f?w:r;case"`":return u;case"}":return 1===f?w:u;default:if("true"===a||"false"===a)return B;if("null"===a)return A;if(b=g.charCodeAt(0),32===b||9===b||W.test(g))return s;if(c(b))return t;if(d(g))return w;if(e(g))return y;if(N.test(a))return C;if(P.test(a))return z}},addLoc:function(a,b,c,d,e){a.loc={start:{line:b,column:c},end:{line:d,column:e}}},parseTemplate:function(a,b,c){var d=this.parseTemplateBlock(a,c),e=this.parseTemplateExpr(d);n.apply(b,e)},parseTemplateExpr:function(a){for(var b=[],c=0,d=a.length;d>c;c++){var e=a[c];if("tmp-source"===e.type){var g=f({},e._loc,{type:u}),h=this._retokenize(e.value,g);n.apply(b,h)}else b[b.length]=e}return b},parseTemplateBlock:function(a,b){for(var d,e,f,g,h,i,j,k,l=a.match($),m=this.line,n=m,o=this.index,p=[this.prevLineIndex],q=[],r=0,s="",t=u,v=0,w=0,x=0,y=l.length;y>x;g=l[x++]){var z=l[x],A=z.length;if(c(z.charCodeAt(0))&&(m++,p[p.length]=o+w+A),h){switch(z){case"{":v++;break;case"}":v--}0===v&&y>x+1&&"}"===l[x+1]&&(j=!0,t="tmp-source",h=!1)}else"\\"===z?"\\"===g?r++:r=1:"$"===z?i="\\"!==g||r%2===0:"{"===z&&i&&"$"===g&&(j=!0,t=u,h=!0);s+=z,x===y-1&&(j=!0,t=u),j&&(k={type:t,value:s},d=o+w+A,e=this.findPrevLineIndex(p,d),f=d-e,t===u?(this.options.range&&(k.range=[d-s.length,d]),this.options.loc&&this.addLoc(k,n,b,m,f),b=f+A):(d=o+w+A-s.length,e=this.findPrevLineIndex(p,d),k._loc={line:n,index:d,prevLineIndex:e},b=f),q[q.length]=k,s="",n=m,j=!1),w+=A}return this.line=n,this.index=d,this.prevLineIndex=e,q},findPrevLineIndex:function(a,b){for(var c=a.length-1;c>=0;--c){var d=a[c];if(b>=d)return d}},fixRegExpTokens:function(a,b,c,d){for(var e=c.length;--e>=0;){var f=c[e],g=f.type;if(g!==r&&g!==s&&g!==t){var h=f.value;if(g===w){if(")"===h){if(this.isValidRegExpPrefix(c,e+1))break}else if(X.test(h))break}else if(g===C&&X.test(h)||g===u&&"${"===h.slice(-2))break;var i=d.match(_);return p.apply(a,[b,1].concat(i)),!0}}return!1},isValidRegExpPrefix:function(a,b){for(var c,d,e,f=0;--b>=0;)if(c=a[b],c.type===w)if(d=c.value,"("===d){if(0===--f)return e=a[b-1],e&&e.type===C&&Y.test(e.value)?!0:!1}else")"===d&&f++;return!1},_retokenize:function(a,b){var c=new g(this.options);return f(c,b),c.tokenize(a)},tokenize:function(a){if(null==a)return[];a=""+a;var b;b=this.options.whiteSpace||this.options.range||this.options.loc?aa:Z;var c=[],d=a.match(b);return d&&this.parseMatches(d,c),c}},l.Tokenizer=g;var ba=l.tokenize=function(a,b){return new g(b).tokenize(a)};h.prototype={untokenize:function(a){for(var b,c=[],d=0,e=a.length;e>d;b=a[d++]){var f=a[d],g=f.type,h=f.value;if(b&&!this.options.unsafe){var i,j=(b.type,b.value);i=g===w?S.test(h)&&T.test(j):Q.test(h)&&R.test(j),c[c.length]=(i?" ":"")+h}else c[c.length]=h}return c.join("")}},l.Untokenizer=h;var ca=l.untokenize=function(a,b){return new h(b).untokenize(a)},da={},ea={maxLineLen:32e3};i.prototype={init:function(){this.index=0,this.lineLen=0,this.current()},next:function(){return this.index++,this.current()},current:function(){return this.length=this.tokens.length,this.prev=this.tokens[this.index-1]||{},this.token=this.tokens[this.index]||da,this.value=this.token.value,this.type=this.token.type,this.lookahead=this.tokens[this.index+1]||da,this.token},remove:function(a){null==a&&(a=this.index),this.tokens.splice(a,1),this.current()},insert:function(a){this.tokens.splice(this.index+1,0,a),this.next()},eat:function(a){for(a=a||t;this.type===a;)this.remove()},flatten:function(){for(this.init(),this.eat();this.index<this.length;){if(this.type===t){if(this.prev.type===w||this.prev.type===t||this.lookahead.type===w){this.eat();continue}if(this.lookahead.type===t){this.next(),this.eat();continue}}this.next()}},breakLine:function(){for(this.init();this.index<this.length;)this.type===t?this.lineLen=0:(this.lineLen+=this.value.length,this.lineLen>=this.options.maxLineLen&&(this.type!==w||T.test(this.value)||(this.insert({type:t,value:"\n"}),this.lineLen=0))),this.next()},compress:function(){this.flatten(),this.breakLine()},minify:function(a){return this.tokens=ba(a,{lineTerminator:!0}),this.init(),this.compress(),
ca(this.tokens)}},l.Minifier=i;var fa=(l.minify=function(a,b){return new i(b).minify(a)},"AssignmentExpression"),ga="AssignmentPattern",ha="ArrayExpression",ia="ArrayPattern",ja="ArrowFunctionExpression",ka="ArrowParameters",la="BlockStatement",ma="BinaryExpression",na="BreakStatement",oa="CallExpression",pa="CatchClause",qa="ConditionalExpression",ra="ContinueStatement",sa="DoWhileStatement",ta="DebuggerStatement",ua="EmptyStatement",va="ExportAllDeclaration",wa="ExportDefaultDeclaration",xa="ExportNamedDeclaration",ya="ExportSpecifier",za="ExpressionStatement",Aa="ForStatement",Ba="ForOfStatement",Ca="ForInStatement",Da="FunctionDeclaration",Ea="FunctionExpression",Fa="IfStatement",Ga="ImportDeclaration",Ha="ImportDefaultSpecifier",Ia="ImportNamespaceSpecifier",Ja="ImportSpecifier",Ka="Literal",La="LabeledStatement",Ma="LogicalExpression",Na="MemberExpression",Oa="NewExpression",Pa="ObjectExpression",Qa="ObjectPattern",Ra="Program",Sa="Property",Ta="RestElement",Ua="ReturnStatement",Va="SequenceExpression",Wa="SpreadElement",Xa="SwitchCase",Ya="SwitchStatement",Za="TaggedTemplateExpression",$a="TemplateElement",_a="TemplateLiteral",ab="ThisExpression",bb="ThrowStatement",cb="TryStatement",db="UnaryExpression",eb="UpdateExpression",fb="VariableDeclaration",gb="VariableDeclarator",hb="WhileStatement",ib="WithStatement",jb=/^(?:[-+*%\/&|]?=|>>>?=|<<=)$/,kb=/^(?:[-+!~]|\+\+|--|typeof|void|delete)$/,lb=/^0[0-7]+$/;k.prototype={next:function(){this.token===da&&this.throwError("Unexpected end of input"),this.token=this.tokens[++this.index]||da,this.value=this.token.value,this.type=this.token.type},lookahead:function(){return this.tokens[this.index+1]||da},assertValue:function(a){this.value!==a&&this.unexpected()},assertType:function(a){this.type!==a&&this.unexpected()},expect:function(a){this.assertValue(a),this.next()},expectType:function(a){this.assertType(a),this.next()},expectSemicolon:function(){return";"===this.value?(this.next(),!0):"}"===this.value||this.token.hasLineTerminator||this.token===da?!0:void this.unexpected()},unexpected:function(){var a=this.value||"";a.length>10&&(a=a.substr(0,10)+"..."),this.throwError("Unexpected token '"+a+"'")},throwError:function(a){var b=this.token.loc;throw b&&(a+=" at line "+b.start.line+" column "+b.start.column),new Error(a)},startNode:function(a){var b=new j;return this.startNodeAt(b),b.type=a,b},finishNode:function(a){if(this.lastGroup&&this.lastGroup.expr===a){var b=this.lastGroup.startNode,c=this.lastGroup.endToken;return this.lastGroup=null,this.startNodeAt(a,b),this.finishNodeAt(a,c)}return this.finishNodeAt(a)},startNodeAt:function(a,b){if(b=b||this.token,b===da&&(0===this.length?b=this.getInitialLocationNode():this.unexpected()),this.options.range&&(a.range=a.range||[],a.range[0]=b.range[0]),this.options.loc){var c=b.loc;a.loc=a.loc||{},a.loc.start={line:c.start.line,column:c.start.column}}return a},finishNodeAt:function(a,b){return b=b||this.tokens[this.index-1],b||(0===this.length?b=this.getInitialLocationNode():this.unexpected()),this.options.range&&(a.range[1]=b.range[1]),this.options.loc&&(a.loc.end={line:b.loc.end.line,column:b.loc.end.column}),a},getInitialLocationNode:function(){return{range:[0,0],loc:{start:{line:0,column:0},end:{line:0,column:0}}}},parseNumeric:function(a){var b,c=0,d=a.charAt(c++);if("0"===d&&(d=a.charAt(c++),b=a.substring(c),"."!==d)){switch(d.toLowerCase()){case"x":return parseInt(b,16);case"o":return parseInt(b,8);case"b":return parseInt(b,2)}if(lb.test(a))return parseInt(d+b,8)}return parseFloat(a)},parseString:function(a){for(var d,e,f,g,h,i,j="",k=1,l=a.length-1;l>k;){if(d=a.charAt(k++),"\\"===d){if(l>k&&(e=a.charCodeAt(k),c(e))){k++,13===e&&l>k&&10===a.charCodeAt(k)&&k++;continue}switch(d=a.charAt(k++)){case"b":d="\b";break;case"t":d="\t";break;case"r":d="\r";break;case"n":d="\n";break;case"v":d="\x0B";break;case"f":d="\f";break;case"u":case"x":"u"===d&&l>k&&"{"===a.charAt(k)?(k++,h=a.indexOf("}",k),~h||this.unexpected(),f=a.substring(k,h),k=h+1):(i="u"===d?4:2,f=a.substr(k,i),k+=i),d=b(parseInt(f,16));break;case"0":case"1":case"2":case"3":case"4":case"5":case"6":case"7":g=d;do{if(d=a.charAt(k),"0">d||d>"7")break;g+=d}while(k++<l&&g.length<3);g.length>0&&"0"===g.charAt(0)&&(g=g.substring(1)),d=q(parseInt(g,8))}}j+=d}return j},parseLiteral:function(){var a,b,c=this.startNode(Ka),d=this.value;switch(this.type){case y:a=this.parseNumeric(d);break;case v:a=this.parseString(d);break;case x:b=this.token.regex;try{a=new RegExp(b.pattern,b.flags)}catch(e){a=null}b=b;break;case B:a="true"===d;break;case A:a=null;break;default:this.unexpected()}return this.next(),c.value=a,c.raw=d,b&&(c.regex=b),this.finishNode(c)},parseIdentifier:function(a){var b=this.startNode(z),c=this.value;return a?this.next():this.expectType(z),b.name=c,this.finishNode(b)},parseCommaSeparatedElements:function(a,b,c,d,e){for(this.expect(a);this.value!==b;)c[c.length]=d.apply(this,e),this.value!==b&&this.expect(",");return this.expect(b),c},parsePrimaryExpression:function(){switch(this.type){case y:case v:case x:case B:case A:return this.parseLiteral();case z:return this.parseIdentifier();case C:return this.parsePrimaryKeywordExpression();case w:return this.parsePrimaryPunctuatorExpression();case u:return this.parseTemplateLiteral();default:this.unexpected()}},parsePrimaryKeywordExpression:function(){switch(this.value){case"function":return this.parseFunctionExpression();case"this":return this.parseThisExpression()}this.unexpected()},parseThisExpression:function(){var a=this.startNode(ab);return this.expect("this"),this.finishNode(a)},parsePrimaryPunctuatorExpression:function(){switch(this.value){case"{":return this.parseObjectInitializer();case"[":return this.parseArrayInitializer();case"(":return this.parseGroupExpression();default:this.unexpected()}},parseGroupExpression:function(){var a=this.startNode();if(this.expect("("),")"===this.value)return this.next(),this.assertValue("=>"),{type:ka,params:[],startNode:a};var b=this.startNode(),c=this.parseExpression(!0);if(this.lastGroup={expr:c,startNode:b,endToken:this.tokens[this.index-1]},this.expect(")"),"=>"===this.value){var d=[];c.type===Va?d=c.expressions:c.type===z?d=[c]:this.unexpected(),c={type:ka,params:d,startNode:a}}return c},parseObjectInitializer:function(){var a=this.startNode(Pa);return a.properties=this.parseCommaSeparatedElements("{","}",[],this.parseObjectDefinition),this.finishNode(a)},parseObjectDefinition:function(){var a;return a="get"===this.value||"set"===this.value?this.parseObjectGetterSetter():this.parseObjectProperty()},parseObjectProperty:function(){var a,b=this.startNode(Sa);"*"===this.value&&(a=!0,this.next());var c,d=this.parseObjectPropertyName();return":"===this.value?(this.next(),c=this.parseAssignmentExpression(!0)):"("===this.value?c=this.parseFunction({expression:!0,generator:a}):this.unexpected(),b.key=d,b.value=c,b.kind="init",this.finishNode(b)},parseObjectGetterSetter:function(){var a,b,c=this.startNode(Sa),d=this.lookahead(),e="init";if(":"===d.value)a=this.parseObjectPropertyName(),this.next(),b=this.parseAssignmentExpression(!0);else if("("===d.value)a=this.parseObjectPropertyName(),b=this.parseFunction({expression:!0});else{var f=this.value;this.next(),this.type===z||this.type===C||this.type===v||this.type===y?(e=f,a=this.parseObjectPropertyName(),b=this.parseFunction({getter:"get"===e,setter:"set"===e,expression:!0})):this.unexpected()}return c.key=a,c.value=b,c.kind=e,this.finishNode(c)},parseObjectPropertyName:function(){var a;switch(this.type){case v:case y:return this.parseLiteral();case w:if("["===this.value)return this.next(),a=this.parseAssignmentExpression(),this.expect("]"),a;break;case C:case z:case B:case A:return this.parseIdentifier(!0)}this.unexpected()},parseArrayInitializer:function(){var a=this.startNode(ha),b=[];for(this.expect("[");"]"!==this.value;)","!==this.value?("..."===this.value?b[b.length]=this.parseSpreadElement():b[b.length]=this.parseAssignmentExpression(!0),"]"!==this.value&&this.expect(",")):(this.next(),
b[b.length]=null);return this.expect("]"),a.elements=b,this.finishNode(a)},parseSpreadElement:function(){var a=this.parseRestElement();return a.type=Wa,a},parseExpression:function(a){var b=this.startNode(Va),c=this.parseAssignmentExpression(a);if(","!==this.value)return c;var d=[c];do this.next(),d[d.length]=this.parseAssignmentExpression(a);while(","===this.value);return b.expressions=d,this.finishNode(b)},parseAssignmentExpression:function(a){var b=this.startNode(fa),c=this.parseConditionalExpression(a);if("=>"===this.value&&c.type===ka)return this.parseArrowFunctionExpression(c);if(!jb.test(this.value))return c;var d=this.value;this.next();var e=this.parseAssignmentExpression(a);return b.operator=d,b.left=c,b.right=e,this.finishNode(b)},parseConditionalExpression:function(a){var b=this.startNode(qa),c=this.parseBinaryExpression(a);if("?"!==this.value)return c;this.expect("?");var d=this.parseAssignmentExpression(!0);this.expect(":");var e=this.parseAssignmentExpression(a);return b.test=c,b.consequent=d,b.alternate=e,this.finishNode(b)},parseArrowFunctionExpression:function(a){var b=this.startNode(ja);this.startNodeAt(b,a.startNode),this.expect("=>");var c,d=a.params||[],e=!1;return"{"===this.value?c=this.parseBlockStatement():(c=this.parseAssignmentExpression(!0),e=!0),b.params=d,b.body=c,b.expression=e,this.finishNode(b)},getBinaryPrecedence:function(a){switch(this.value){case"*":case"/":case"%":return 1;case"+":case"-":return 2;case"<<":case">>":case">>>":return 3;case"<":case">":case"<=":case">=":case"instanceof":return 4;case"in":return a?4:0;case"==":case"!=":case"===":case"!==":return 5;case"&":return 6;case"^":return 7;case"|":return 8;case"&&":return 9;case"||":return 10;default:return 0}},parseBinaryExpression:function(a,b){null==b&&(b=10);var c=this.startNode(),d=this.parseUnaryExpression(),e=this.getBinaryPrecedence(a);if(!e)return d;for(var f,g,h,i=1;10>=i;i++){for(;(e=this.getBinaryPrecedence(a))===i;)g=this.value,h=this.startNode(9>i?ma:Ma),this.startNodeAt(h,c),h.operator=g,h.left=d,this.next(),f=1===e?this.parseUnaryExpression():this.parseBinaryExpression(a,e-1),h.right=f,d=this.finishNode(h);if(e>b)break}return this.startNodeAt(d,c),this.finishNode(d)},parseUnaryExpression:function(){var a=this.value;if(!kb.test(a))return this.parsePostfixExpression();var b="++"===a||"--"===a,c=this.startNode(b?eb:db);this.next();var d=this.parseUnaryExpression();return c.operator=a,c.argument=d,c.prefix=!0,this.finishNode(c)},parsePostfixExpression:function(){var a=this.startNode(eb),b=this.parseMemberExpression(!0),c=this.value;return"++"===c||"--"===c?(this.next(),a.operator=c,a.argument=b,a.prefix=!1,this.finishNode(a)):b},parseMemberExpression:function(a){var b,c=this.startNode();for(b="new"===this.value?this.parseNewExpression():this.parsePrimaryExpression();;)if("."===this.value)b=this.parseNonComputedMember(b,c);else if("["===this.value)b=this.parseComputedMember(b,c);else if(a&&"("===this.value)b=this.parseCallExpression(b,c);else{if(this.type!==u||"`"!==this.value.charAt(0))break;b=this.parseTaggedTemplateExpression(b,c)}return b},parseNewExpression:function(){var a=this.startNode(Oa);this.next();var b=this.parseMemberExpression(!1);return a.callee=b,a.arguments=[],"("===this.value&&this.parseArguments(a),this.finishNode(a)},parseCallExpression:function(a,b){var c=this.startNode(oa);return this.startNodeAt(c,b),c.callee=a,c.arguments=[],this.parseArguments(c),this.finishNode(c)},parseComputedMember:function(a,b){var c=this.startNode(Na);return this.startNodeAt(c,b),this.next(),c.computed=!0,c.object=a,c.property=this.parseExpression(!0),this.expect("]"),this.finishNode(c)},parseNonComputedMember:function(a,b){var c=this.startNode(Na);return this.startNodeAt(c,b),this.next(),c.computed=!1,c.object=a,c.property=this.parseIdentifier(),this.finishNode(c)},parseArguments:function(a){return this.parseCommaSeparatedElements("(",")",a.arguments,this.parseAssignmentExpression,[!0]),a},parseTemplateLiteral:function(){for(var a=this.startNode(_a),b=this.parseTemplateElement(),c=[b],d=[];!b.tail;)d[d.length]=this.parseExpression(),b=this.parseTemplateElement(),c[c.length]=b;return a.quasis=c,a.expressions=d,this.finishNode(a)},parseTemplateElement:function(){var a,b=this.startNode($a),c=!1;this.assertType(u),"`"===this.value.slice(-1)&&(c=!0);var d=(this.value.charAt(0),c?-1:-2);a=this.value.slice(1,d);var e=this.parseString("`"+a+"`");return this.next(),b.tail=c,b.value={cooked:e,raw:a},this.finishNode(b)},parseTaggedTemplateExpression:function(a,b){var c=this.startNode(Za);this.startNodeAt(c,b);var d=this.parseTemplateLiteral();return c.tag=a,c.quasi=d,this.finishNode(c)},parseStatement:function(){switch(this.value){case"{":return this.parseBlockStatement();case"var":case"let":case"const":return this.parseVariableStatement(this.value);case";":return this.parseEmptyStatement();case"if":return this.parseIfStatement();case"continue":return this.parseContinueStatement();case"break":return this.parseBreakStatement();case"return":return this.parseReturnStatement();case"with":return this.parseWithStatement();case"throw":return this.parseThrowStatement();case"try":return this.parseTryStatement();case"debugger":return this.parseDebuggerStatement();case"function":return this.parseFunctionDeclaration();case"switch":return this.parseSwitchStatement();case"do":return this.parseDoWhileStatement();case"while":return this.parseWhileStatement();case"for":return this.parseForStatement();case"import":return this.parseImportDeclaration();case"export":return this.parseExportDeclaration();default:return this.parseMaybeExpressionStatement()}},parseScriptBody:function(a,b){for(;this.value!==b;)a[a.length]=this.parseStatement()},parseBlockStatement:function(){var a=this.startNode(la);this.expect("{");var b=[];return this.parseScriptBody(b,"}"),this.expect("}"),a.body=b,this.finishNode(a)},parseVariableStatement:function(a,b){var c=this.startNode(fb),d=!b,e=this.parseVariableDeclarationList(d);return b||this.expectSemicolon(),c.declarations=e,c.kind=a,this.finishNode(c)},parseVariableDeclarationList:function(a){var b=[];do b[b.length]=this.parseVariableDeclaration(a);while(","===this.value);return b},parseVariableDeclaration:function(a){this.next();var b=this.startNode(gb),c=this.parseBindingPattern(),d=null;return"="===this.value&&(this.next(),d=this.parseAssignmentExpression(a)),b.id=c,b.init=d,this.finishNode(b)},parseFunctionDeclaration:function(){return this.parseFunctionDefinition()},parseFunctionExpression:function(){return this.parseFunctionDefinition(!0)},parseFunctionDefinition:function(a){var b=this.startNode(),c=!1;return this.expect("function"),"*"===this.value&&(c=!0,this.next()),this.parseFunction({node:b,generator:c,expression:a})},parseFunction:function(a){a=a||{};var b=a.node||this.startNode();return b.type=a.expression?Ea:Da,b.id=null,b.params=[],b.defaults=[],b.body=null,b.generator=!!a.generator,b.expression=!1,a.getter?(this.expect("("),this.expect(")")):a.setter?this.parseParams(b):(this.type===z&&(b.id=this.parseIdentifier()),this.parseParams(b)),b.body=this.parseBlockStatement(),this.finishNode(b)},parseParams:function(a){for(this.expect("(");")"!==this.value&&this.parseParam(a););a._hasDefaults?delete a._hasDefaults:a.defaults.length=0,this.expect(")")},parseParam:function(a){var b=a.params,c=a.defaults;if("..."===this.value)return b[b.length]=this.parseRestElement(),c[c.length]=null,!1;var d=this.parseBindingElement();return d.type===ga?(b[b.length]=d.left,c[c.length]=d.right,a._hasDefaults=!0):(b[b.length]=d,c[c.length]=null),")"!==this.value&&this.expect(","),!0},parseRestElement:function(){var a=this.startNode(Ta);this.expect("...");var b=this.parseIdentifier();return a.argument=b,this.finishNode(a)},parseBindingPattern:function(){return this.type===z?this.parseIdentifier():"{"===this.value?this.parseObjectPattern():"["===this.value?this.parseArrayPattern():void this.unexpected()},parseBindingElement:function(){var a=this.parseBindingPattern();
return a.type===z&&"="===this.value?this.parseAssignmentPattern(a):a},parseAssignmentPattern:function(a){this.expect("=");var b=this.startNode(ga);this.startNodeAt(b,a);var c=this.parseAssignmentExpression(!0);return b.left=a,b.right=c,this.finishNode(b)},parseArrayPattern:function(){var a=this.startNode(ia),b=[];for(this.expect("[");"]"!==this.value;){if(","===this.value)b[b.length]=null;else{if("..."===this.value){b[b.length]=this.parseRestElement();break}b[b.length]=this.parseBindingElement()}"]"!==this.value&&this.expect(",")}return this.expect("]"),a.elements=b,this.finishNode(a)},parseObjectPattern:function(){var a=this.startNode(Qa);return a.properties=this.parseCommaSeparatedElements("{","}",[],this.parseObjectPropertyPattern),this.finishNode(a)},parseObjectPropertyPattern:function(){var a,b,c=this.startNode(Sa);return this.type===z?(a=this.parseIdentifier(),"="===this.value?(b=this.parseAssignmentPattern(a),this.startNodeAt(b,c)):":"!==this.value&&(b=a)):a=this.parseObjectPropertyName(),b||(this.expect(":"),b=this.parseBindingElement()),c.key=a,c.value=b,c.kind="init",this.finishNode(c)},parseIfStatement:function(){var a=this.startNode(Fa);this.expect("if"),this.expect("(");var b=this.parseExpression(!0);this.expect(")");var c=this.parseStatement(),d=null;return"else"===this.value&&(this.next(),d=this.parseStatement()),a.test=b,a.consequent=c,a.alternate=d,this.finishNode(a)},parseEmptyStatement:function(){var a=this.startNode(ua);return this.expect(";"),this.finishNode(a)},parseContinueStatement:function(){var a=this.startNode(ra);this.expect("continue");var b=null;return this.type!==z||this.token.hasLineTerminator||(b=this.parseIdentifier()),this.expectSemicolon(),a.label=b,this.finishNode(a)},parseBreakStatement:function(){var a=this.startNode(na);this.expect("break");var b=null;return this.type!==z||this.token.hasLineTerminator||(b=this.parseIdentifier()),this.expectSemicolon(),a.label=b,this.finishNode(a)},parseReturnStatement:function(){var a=this.startNode(Ua);this.expect("return");var b=null;return";"===this.value||"}"===this.value||this.token.hasLineTerminator||this.token===da||(b=this.parseExpression(!0)),this.expectSemicolon(),a.argument=b,this.finishNode(a)},parseWithStatement:function(){var a=this.startNode(ib);this.expect("with"),this.expect("(");var b=this.parseExpression(!0);return this.expect(")"),a.object=b,a.body=this.parseStatement(),this.finishNode(a)},parseThrowStatement:function(){var a=this.startNode(bb);this.expect("throw"),this.token.hasLineTerminator&&this.unexpected();var b=this.parseExpression(!0);return this.expectSemicolon(),a.argument=b,this.finishNode(a)},parseTryStatement:function(){var a,b,c=this.startNode(cb),d=null,e=null;this.expect("try");var f=this.parseBlockStatement();return"catch"===this.value&&(a=!0,d=this.parseCatchClause()),"finally"===this.value&&(b=!0,this.next(),e=this.parseBlockStatement()),a||b||this.unexpected(),c.block=f,c.guardedHandlers=[],c.handler=d,c.finalizer=e,this.finishNode(c)},parseCatchClause:function(){var a=this.startNode(pa);this.expect("catch"),this.expect("(");var b=this.parseBindingPattern();this.expect(")");var c=this.parseBlockStatement();return a.param=b,a.body=c,this.finishNode(a)},parseDebuggerStatement:function(){var a=this.startNode(ta);return this.expect("debugger"),this.expectSemicolon(),this.finishNode(a)},parseSwitchStatement:function(){var a=this.startNode(Ya);this.expect("switch"),this.expect("(");var b=this.parseExpression(!0),c=[];for(this.expect(")"),this.expect("{");"}"!==this.value;)c[c.length]=this.parseSwitchCase();return this.expect("}"),a.discriminant=b,a.cases=c,this.finishNode(a)},parseSwitchCase:function(){var a=this.startNode(Xa),b=null,c=[];for("case"===this.value?(this.next(),b=this.parseExpression(!0)):this.expect("default"),this.expect(":");"}"!==this.value&&"case"!==this.value&&"default"!==this.value&&this.token!==da;)c[c.length]=this.parseStatement();return a.test=b,a.consequent=c,this.finishNode(a)},parseWhileStatement:function(){var a=this.startNode(hb);this.expect("while"),this.expect("(");var b=this.parseExpression(!0);return this.expect(")"),a.test=b,a.body=this.parseStatement(),this.finishNode(a)},parseDoWhileStatement:function(){var a=this.startNode(sa);this.expect("do");var b=this.parseStatement();this.expect("while"),this.expect("(");var c=this.parseExpression(!0);return this.expect(")"),this.expectSemicolon(),a.body=b,a.test=c,this.finishNode(a)},parseForStatement:function(){var a=this.startNode(Aa);this.expect("for"),this.expect("(");var b=null;if(";"!==this.value&&(b="var"===this.value||"let"===this.value||"const"===this.value?this.parseForVarStatement(a):this.parseForExpressionStatement(a),b.type===Ca||b.type===Ba))return b;this.expect(";");var c=null;";"!==this.value&&(c=this.parseExpression(!0)),this.expect(";");var d=null;")"!==this.value&&(d=this.parseExpression(!0)),this.expect(")");var e=this.parseStatement();return a.init=b,a.test=c,a.update=d,a.body=e,this.finishNode(a)},parseForExpressionStatement:function(a){var b=this.parseExpression(!1);return"in"===this.value?this.parseForInStatement(b,a):"of"===this.value?this.parseForOfStatement(b,a):b},parseForVarStatement:function(a){var b=this.value,c=this.parseVariableStatement(b,!0);return"in"===this.value?this.parseForInStatement(c,a):"of"===this.value?this.parseForOfStatement(c,a):c},parseForInStatement:function(a,b){b.type=Ca,this.expect("in");var c=this.parseExpression(!0);this.expect(")");var d=this.parseStatement();return b.left=a,b.right=c,b.body=d,b.each=!1,this.finishNode(b)},parseForOfStatement:function(a,b){b.type=Ba,this.expect("of");var c=this.parseExpression(!0);this.expect(")");var d=this.parseStatement();return b.left=a,b.right=c,b.body=d,this.finishNode(b)},parseImportDeclaration:function(){var a=this.startNode(Ga);return this.expect("import"),a.specifiers=this.parseImportClause(),"from"===this.value&&this.next(),this.assertType(v),a.source=this.parseLiteral(),this.expectSemicolon(),this.finishNode(a)},parseImportClause:function(){var a=[];if(this.type===v)return a;if(this.type===z){if("from"===this.value&&this.unexpected(),a[a.length]=this.parseImportDefaultSpecifier(),","!==this.value)return a;this.next()}if("*"===this.value){if(a[a.length]=this.parseImportNamespaceSpecifier(),","!==this.value)return a;this.next()}return"{"===this.value&&this.parseCommaSeparatedElements("{","}",a,this.parseImportSpecifier),a},parseImportSpecifier:function(){var a,b=this.startNode(Ja),c=this.parseIdentifier();return"as"===this.value&&(this.next(),a=this.parseIdentifier()),b.local=a||c,b.imported=c,this.finishNode(b)},parseImportNamespaceSpecifier:function(){var a=this.startNode(Ia);return this.expect("*"),this.expect("as"),a.local=this.parseIdentifier(),this.finishNode(a)},parseImportDefaultSpecifier:function(){var a=this.startNode(Ha);return a.local=this.parseIdentifier(),this.finishNode(a)},parseExportDeclaration:function(){var a=this.startNode();return this.expect("export"),"default"===this.value?this.parseExportDefaultDeclaration(a):"*"===this.value?this.parseExportAllDeclaration(a):this.parseExportNamedDeclaration(a)},parseExportDefaultDeclaration:function(a){a.type=wa,this.expect("default");var b,c;return"function"===this.value?(b=this.parseFunctionDeclaration(),c=!0):b=this.parseAssignmentExpression(!0),c||this.expectSemicolon(),a.declaration=b,this.finishNode(a)},parseExportAllDeclaration:function(a){return a.type=va,this.expect("*"),this.expect("from"),this.assertType(v),a.source=this.parseLiteral(),this.expectSemicolon(),this.finishNode(a)},parseExportNamedDeclaration:function(a){a.type=xa;var b=null,c=[],d=null;return this.type===C?b=this.parseStatement():(this.parseCommaSeparatedElements("{","}",c,this.parseExportSpecifier),"from"===this.value&&(this.next(),this.assertType(v),d=this.parseLiteral()),this.expectSemicolon()),a.declaration=b,a.specifiers=c,a.source=d,this.finishNode(a)},parseExportSpecifier:function(){var a,b=this.startNode(ya),c=this.parseIdentifier();
return"as"===this.value&&(this.next(),a=this.parseIdentifier()),b.exported=a||c,b.local=c,this.finishNode(b)},parseMaybeExpressionStatement:function(){var a=this.parseMaybeLabelledStatement();if(a)return a;var b=this.startNode(za),c=this.parseExpression(!0);return this.expectSemicolon(),b.expression=c,this.finishNode(b)},parseMaybeLabelledStatement:function(){if(this.type===z&&":"===this.lookahead().value){var a=this.startNode(La),b=this.parseIdentifier();this.next();var c=this.parseStatement();return a.label=b,a.body=c,this.finishNode(a)}},parse:function(a){a=null==a?"":""+a,this.tokens=ba(a,{range:this.options.range,loc:this.options.loc,parse:!0}),this.length=this.tokens.length,this.index=-1,this.next();var b=this.startNode(Ra);return b.body=[],this.parseScriptBody(b.body),this.finishNode(b)}},l.Parser=k;l.parse=function(a,b){return new k(b).parse(a)};return l});